--- asterisk/channel.c.ORIG	2004-06-12 12:03:05.000000000 +0200
+++ asterisk/channel.c	2004-06-12 12:02:48.000000000 +0200
@@ -756,6 +756,9 @@
 	switch(chan->_state) {
 	case AST_STATE_RINGING:
 	case AST_STATE_RING:
+	case AST_STATE_RESERVED:
+	case AST_STATE_OFFHOOK:
+	case AST_STATE_DIALING:
 		ast_mutex_lock(&chan->lock);
 		if (chan->pvt->answer)
 			res = chan->pvt->answer(chan);
--- asterisk/channels/chan_zap.c.ORIG	2004-06-12 12:01:03.000000000 +0200
+++ asterisk/channels/chan_zap.c	2004-06-12 12:01:52.000000000 +0200
@@ -4048,7 +4048,7 @@
 			break;
 		case AST_CONTROL_RINGING:
 #ifdef ZAPATA_PRI
-			if (!p->proceeding && p->sig==SIG_PRI && p->pri && !p->outgoing) {
+			if (/*!p->proceeding &&*/ p->sig==SIG_PRI && p->pri && !p->outgoing) {
 				if (p->pri->pri) {		
 					if (!pri_grab(p, p->pri)) {
 						pri_acknowledge(p->pri->pri,p->call, PVT_TO_CHANNEL(p), 1);
